//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the amcl package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __amcl__AMCLCONFIG_H__
#define __amcl__AMCLCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace amcl
{
  class AMCLConfigStatics;
  
  class AMCLConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(AMCLConfig &config, const AMCLConfig &max, const AMCLConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const AMCLConfig &config1, const AMCLConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, AMCLConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const AMCLConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, AMCLConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const AMCLConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T AMCLConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (AMCLConfig::* field);

      virtual void clamp(AMCLConfig &config, const AMCLConfig &max, const AMCLConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const AMCLConfig &config1, const AMCLConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, AMCLConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const AMCLConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, AMCLConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const AMCLConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 11 "../cfg/AMCL.cfg"
      int min_particles;
//#line 12 "../cfg/AMCL.cfg"
      int max_particles;
//#line 14 "../cfg/AMCL.cfg"
      double kld_err;
//#line 15 "../cfg/AMCL.cfg"
      double kld_z;
//#line 17 "../cfg/AMCL.cfg"
      double update_min_d;
//#line 18 "../cfg/AMCL.cfg"
      double update_min_a;
//#line 20 "../cfg/AMCL.cfg"
      int resample_interval;
//#line 22 "../cfg/AMCL.cfg"
      double transform_tolerance;
//#line 24 "../cfg/AMCL.cfg"
      double recovery_alpha_slow;
//#line 25 "../cfg/AMCL.cfg"
      double recovery_alpha_fast;
//#line 27 "../cfg/AMCL.cfg"
      double gui_publish_rate;
//#line 28 "../cfg/AMCL.cfg"
      double save_pose_rate;
//#line 30 "../cfg/AMCL.cfg"
      bool use_map_topic;
//#line 31 "../cfg/AMCL.cfg"
      bool first_map_only;
//#line 34 "../cfg/AMCL.cfg"
      double laser_min_range;
//#line 35 "../cfg/AMCL.cfg"
      double laser_max_range;
//#line 37 "../cfg/AMCL.cfg"
      int laser_max_beams;
//#line 39 "../cfg/AMCL.cfg"
      double laser_z_hit;
//#line 40 "../cfg/AMCL.cfg"
      double laser_z_short;
//#line 41 "../cfg/AMCL.cfg"
      double laser_z_max;
//#line 42 "../cfg/AMCL.cfg"
      double laser_z_rand;
//#line 44 "../cfg/AMCL.cfg"
      double laser_sigma_hit;
//#line 45 "../cfg/AMCL.cfg"
      double laser_lambda_short;
//#line 46 "../cfg/AMCL.cfg"
      double laser_likelihood_max_dist;
//#line 49 "../cfg/AMCL.cfg"
      std::string laser_model_type;
//#line 53 "../cfg/AMCL.cfg"
      std::string odom_model_type;
//#line 55 "../cfg/AMCL.cfg"
      double odom_alpha1;
//#line 56 "../cfg/AMCL.cfg"
      double odom_alpha2;
//#line 57 "../cfg/AMCL.cfg"
      double odom_alpha3;
//#line 58 "../cfg/AMCL.cfg"
      double odom_alpha4;
//#line 59 "../cfg/AMCL.cfg"
      double odom_alpha5;
//#line 61 "../cfg/AMCL.cfg"
      std::string odom_frame_id;
//#line 62 "../cfg/AMCL.cfg"
      std::string base_frame_id;
//#line 63 "../cfg/AMCL.cfg"
      std::string global_frame_id;
//#line 65 "../cfg/AMCL.cfg"
      bool restore_defaults;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("AMCLConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const AMCLConfig &__max__ = __getMax__();
      const AMCLConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const AMCLConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const AMCLConfig &__getDefault__();
    static const AMCLConfig &__getMax__();
    static const AMCLConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const AMCLConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void AMCLConfig::ParamDescription<std::string>::clamp(AMCLConfig &config, const AMCLConfig &max, const AMCLConfig &min) const
  {
    return;
  }

  class AMCLConfigStatics
  {
    friend class AMCLConfig;
    
    AMCLConfigStatics()
    {
//#line 11 "../cfg/AMCL.cfg"
      __min__.min_particles = 0;
//#line 11 "../cfg/AMCL.cfg"
      __max__.min_particles = 1000;
//#line 11 "../cfg/AMCL.cfg"
      __default__.min_particles = 100;
//#line 11 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<int>("min_particles", "int", 0, "Minimum allowed number of particles.", "", &AMCLConfig::min_particles)));
//#line 12 "../cfg/AMCL.cfg"
      __min__.max_particles = 0;
//#line 12 "../cfg/AMCL.cfg"
      __max__.max_particles = 10000;
//#line 12 "../cfg/AMCL.cfg"
      __default__.max_particles = 5000;
//#line 12 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<int>("max_particles", "int", 0, "Mamimum allowed number of particles.", "", &AMCLConfig::max_particles)));
//#line 14 "../cfg/AMCL.cfg"
      __min__.kld_err = 0.0;
//#line 14 "../cfg/AMCL.cfg"
      __max__.kld_err = 1.0;
//#line 14 "../cfg/AMCL.cfg"
      __default__.kld_err = 0.01;
//#line 14 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("kld_err", "double", 0, "Maximum error between the true distribution and the estimated distribution.", "", &AMCLConfig::kld_err)));
//#line 15 "../cfg/AMCL.cfg"
      __min__.kld_z = 0.0;
//#line 15 "../cfg/AMCL.cfg"
      __max__.kld_z = 1.0;
//#line 15 "../cfg/AMCL.cfg"
      __default__.kld_z = 0.99;
//#line 15 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("kld_z", "double", 0, "Upper standard normal quantile for (1 - p), where p is the probability that the error on the estimated distrubition will be less than kld_err.", "", &AMCLConfig::kld_z)));
//#line 17 "../cfg/AMCL.cfg"
      __min__.update_min_d = 0.0;
//#line 17 "../cfg/AMCL.cfg"
      __max__.update_min_d = 5.0;
//#line 17 "../cfg/AMCL.cfg"
      __default__.update_min_d = 0.2;
//#line 17 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("update_min_d", "double", 0, "Translational movement required before performing a filter update.", "", &AMCLConfig::update_min_d)));
//#line 18 "../cfg/AMCL.cfg"
      __min__.update_min_a = 0.0;
//#line 18 "../cfg/AMCL.cfg"
      __max__.update_min_a = 6.28318530718;
//#line 18 "../cfg/AMCL.cfg"
      __default__.update_min_a = 0.523598775598;
//#line 18 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("update_min_a", "double", 0, "Rotational movement required before performing a filter update.", "", &AMCLConfig::update_min_a)));
//#line 20 "../cfg/AMCL.cfg"
      __min__.resample_interval = 0;
//#line 20 "../cfg/AMCL.cfg"
      __max__.resample_interval = 20;
//#line 20 "../cfg/AMCL.cfg"
      __default__.resample_interval = 2;
//#line 20 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<int>("resample_interval", "int", 0, "Number of filter updates required before resampling.", "", &AMCLConfig::resample_interval)));
//#line 22 "../cfg/AMCL.cfg"
      __min__.transform_tolerance = 0.0;
//#line 22 "../cfg/AMCL.cfg"
      __max__.transform_tolerance = 2.0;
//#line 22 "../cfg/AMCL.cfg"
      __default__.transform_tolerance = 0.1;
//#line 22 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("transform_tolerance", "double", 0, "Time with which to post-date the transform that is published, to indicate that this transform is valid into the future.", "", &AMCLConfig::transform_tolerance)));
//#line 24 "../cfg/AMCL.cfg"
      __min__.recovery_alpha_slow = 0.0;
//#line 24 "../cfg/AMCL.cfg"
      __max__.recovery_alpha_slow = 0.5;
//#line 24 "../cfg/AMCL.cfg"
      __default__.recovery_alpha_slow = 0.0;
//#line 24 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("recovery_alpha_slow", "double", 0, "Exponential decay rate for the slow average weight filter, used in deciding when to recover by adding random poses. A good value might be 0.001.", "", &AMCLConfig::recovery_alpha_slow)));
//#line 25 "../cfg/AMCL.cfg"
      __min__.recovery_alpha_fast = 0.0;
//#line 25 "../cfg/AMCL.cfg"
      __max__.recovery_alpha_fast = 1.0;
//#line 25 "../cfg/AMCL.cfg"
      __default__.recovery_alpha_fast = 0.0;
//#line 25 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("recovery_alpha_fast", "double", 0, "Exponential decay rate for the fast average weight filter, used in deciding when to recover by adding random poses. A good value might be 0.1.", "", &AMCLConfig::recovery_alpha_fast)));
//#line 27 "../cfg/AMCL.cfg"
      __min__.gui_publish_rate = -1.0;
//#line 27 "../cfg/AMCL.cfg"
      __max__.gui_publish_rate = 100.0;
//#line 27 "../cfg/AMCL.cfg"
      __default__.gui_publish_rate = -1.0;
//#line 27 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("gui_publish_rate", "double", 0, "Maximum rate (Hz) at which scans and paths are published for visualization, -1.0 to disable.", "", &AMCLConfig::gui_publish_rate)));
//#line 28 "../cfg/AMCL.cfg"
      __min__.save_pose_rate = 0.0;
//#line 28 "../cfg/AMCL.cfg"
      __max__.save_pose_rate = 10.0;
//#line 28 "../cfg/AMCL.cfg"
      __default__.save_pose_rate = 0.5;
//#line 28 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("save_pose_rate", "double", 0, "Maximum rate (Hz) at which to store the last estimated pose and covariance to the parameter server, in the variables ~initial_pose_* and ~initial_cov_*. This saved pose will be used on subsequent runs to initialize the filter. -1.0 to disable.", "", &AMCLConfig::save_pose_rate)));
//#line 30 "../cfg/AMCL.cfg"
      __min__.use_map_topic = 0;
//#line 30 "../cfg/AMCL.cfg"
      __max__.use_map_topic = 1;
//#line 30 "../cfg/AMCL.cfg"
      __default__.use_map_topic = 0;
//#line 30 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<bool>("use_map_topic", "bool", 0, "When set to true, AMCL will subscribe to the map topic rather than making a service call to receive its map.", "", &AMCLConfig::use_map_topic)));
//#line 31 "../cfg/AMCL.cfg"
      __min__.first_map_only = 0;
//#line 31 "../cfg/AMCL.cfg"
      __max__.first_map_only = 1;
//#line 31 "../cfg/AMCL.cfg"
      __default__.first_map_only = 0;
//#line 31 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<bool>("first_map_only", "bool", 0, "When set to true, AMCL will only use the first map it subscribes to, rather than updating each time a new one is received.", "", &AMCLConfig::first_map_only)));
//#line 34 "../cfg/AMCL.cfg"
      __min__.laser_min_range = -1.0;
//#line 34 "../cfg/AMCL.cfg"
      __max__.laser_min_range = 1000.0;
//#line 34 "../cfg/AMCL.cfg"
      __default__.laser_min_range = -1.0;
//#line 34 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_min_range", "double", 0, "Minimum scan range to be considered; -1.0 will cause the laser's reported minimum range to be used.", "", &AMCLConfig::laser_min_range)));
//#line 35 "../cfg/AMCL.cfg"
      __min__.laser_max_range = -1.0;
//#line 35 "../cfg/AMCL.cfg"
      __max__.laser_max_range = 1000.0;
//#line 35 "../cfg/AMCL.cfg"
      __default__.laser_max_range = -1.0;
//#line 35 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_max_range", "double", 0, "Maximum scan range to be considered; -1.0 will cause the laser's reported maximum range to be used.", "", &AMCLConfig::laser_max_range)));
//#line 37 "../cfg/AMCL.cfg"
      __min__.laser_max_beams = 0;
//#line 37 "../cfg/AMCL.cfg"
      __max__.laser_max_beams = 100;
//#line 37 "../cfg/AMCL.cfg"
      __default__.laser_max_beams = 30;
//#line 37 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<int>("laser_max_beams", "int", 0, "How many evenly-spaced beams in each scan to be used when updating the filter.", "", &AMCLConfig::laser_max_beams)));
//#line 39 "../cfg/AMCL.cfg"
      __min__.laser_z_hit = 0.0;
//#line 39 "../cfg/AMCL.cfg"
      __max__.laser_z_hit = 10.0;
//#line 39 "../cfg/AMCL.cfg"
      __default__.laser_z_hit = 0.95;
//#line 39 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_z_hit", "double", 0, "Mixture weight for the z_hit part of the model.", "", &AMCLConfig::laser_z_hit)));
//#line 40 "../cfg/AMCL.cfg"
      __min__.laser_z_short = 0.0;
//#line 40 "../cfg/AMCL.cfg"
      __max__.laser_z_short = 10.0;
//#line 40 "../cfg/AMCL.cfg"
      __default__.laser_z_short = 0.1;
//#line 40 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_z_short", "double", 0, "Mixture weight for the z_short part of the model.", "", &AMCLConfig::laser_z_short)));
//#line 41 "../cfg/AMCL.cfg"
      __min__.laser_z_max = 0.0;
//#line 41 "../cfg/AMCL.cfg"
      __max__.laser_z_max = 10.0;
//#line 41 "../cfg/AMCL.cfg"
      __default__.laser_z_max = 0.05;
//#line 41 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_z_max", "double", 0, "Mixture weight for the z_max part of the model.", "", &AMCLConfig::laser_z_max)));
//#line 42 "../cfg/AMCL.cfg"
      __min__.laser_z_rand = 0.0;
//#line 42 "../cfg/AMCL.cfg"
      __max__.laser_z_rand = 10.0;
//#line 42 "../cfg/AMCL.cfg"
      __default__.laser_z_rand = 0.05;
//#line 42 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_z_rand", "double", 0, "Mixture weight for the z_rand part of the model.", "", &AMCLConfig::laser_z_rand)));
//#line 44 "../cfg/AMCL.cfg"
      __min__.laser_sigma_hit = 0.0;
//#line 44 "../cfg/AMCL.cfg"
      __max__.laser_sigma_hit = 10.0;
//#line 44 "../cfg/AMCL.cfg"
      __default__.laser_sigma_hit = 0.2;
//#line 44 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_sigma_hit", "double", 0, "Standard deviation for Gaussian model used in z_hit part of the model.", "", &AMCLConfig::laser_sigma_hit)));
//#line 45 "../cfg/AMCL.cfg"
      __min__.laser_lambda_short = 0.0;
//#line 45 "../cfg/AMCL.cfg"
      __max__.laser_lambda_short = 10.0;
//#line 45 "../cfg/AMCL.cfg"
      __default__.laser_lambda_short = 0.1;
//#line 45 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_lambda_short", "double", 0, "Exponential decay parameter for z_short part of model.", "", &AMCLConfig::laser_lambda_short)));
//#line 46 "../cfg/AMCL.cfg"
      __min__.laser_likelihood_max_dist = 0.0;
//#line 46 "../cfg/AMCL.cfg"
      __max__.laser_likelihood_max_dist = 20.0;
//#line 46 "../cfg/AMCL.cfg"
      __default__.laser_likelihood_max_dist = 2.0;
//#line 46 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("laser_likelihood_max_dist", "double", 0, "Maximum distance to do obstacle inflation on map, for use in likelihood_field model.", "", &AMCLConfig::laser_likelihood_max_dist)));
//#line 49 "../cfg/AMCL.cfg"
      __min__.laser_model_type = "";
//#line 49 "../cfg/AMCL.cfg"
      __max__.laser_model_type = "";
//#line 49 "../cfg/AMCL.cfg"
      __default__.laser_model_type = "likelihood_field";
//#line 49 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<std::string>("laser_model_type", "str", 0, "Which model to use, either beam or likelihood_field.", "{'enum_description': 'Laser Models', 'enum': [{'srcline': 48, 'description': 'Use beam laser model', 'srcfile': '../cfg/AMCL.cfg', 'cconsttype': 'const char * const', 'value': 'beam', 'ctype': 'std::string', 'type': 'str', 'name': 'beam_const'}, {'srcline': 48, 'description': 'Use likelihood_field laser model', 'srcfile': '../cfg/AMCL.cfg', 'cconsttype': 'const char * const', 'value': 'likelihood_field', 'ctype': 'std::string', 'type': 'str', 'name': 'likelihood_field_const'}]}", &AMCLConfig::laser_model_type)));
//#line 53 "../cfg/AMCL.cfg"
      __min__.odom_model_type = "";
//#line 53 "../cfg/AMCL.cfg"
      __max__.odom_model_type = "";
//#line 53 "../cfg/AMCL.cfg"
      __default__.odom_model_type = "diff";
//#line 53 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<std::string>("odom_model_type", "str", 0, "Which model to use, either diff or omni", "{'enum_description': 'Odom Models', 'enum': [{'srcline': 52, 'description': 'Use diff odom model', 'srcfile': '../cfg/AMCL.cfg', 'cconsttype': 'const char * const', 'value': 'diff', 'ctype': 'std::string', 'type': 'str', 'name': 'diff_const'}, {'srcline': 52, 'description': 'Use omni odom model', 'srcfile': '../cfg/AMCL.cfg', 'cconsttype': 'const char * const', 'value': 'omni', 'ctype': 'std::string', 'type': 'str', 'name': 'omni_const'}]}", &AMCLConfig::odom_model_type)));
//#line 55 "../cfg/AMCL.cfg"
      __min__.odom_alpha1 = 0.0;
//#line 55 "../cfg/AMCL.cfg"
      __max__.odom_alpha1 = 10.0;
//#line 55 "../cfg/AMCL.cfg"
      __default__.odom_alpha1 = 0.2;
//#line 55 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("odom_alpha1", "double", 0, "Specifies the expected noise in odometry's rotation estimate from the rotational component of the robot's motion.", "", &AMCLConfig::odom_alpha1)));
//#line 56 "../cfg/AMCL.cfg"
      __min__.odom_alpha2 = 0.0;
//#line 56 "../cfg/AMCL.cfg"
      __max__.odom_alpha2 = 10.0;
//#line 56 "../cfg/AMCL.cfg"
      __default__.odom_alpha2 = 0.2;
//#line 56 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("odom_alpha2", "double", 0, "Specifies the expected noise in odometry's rotation estimate from the translational component of the robot's motion.", "", &AMCLConfig::odom_alpha2)));
//#line 57 "../cfg/AMCL.cfg"
      __min__.odom_alpha3 = 0.0;
//#line 57 "../cfg/AMCL.cfg"
      __max__.odom_alpha3 = 10.0;
//#line 57 "../cfg/AMCL.cfg"
      __default__.odom_alpha3 = 0.2;
//#line 57 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("odom_alpha3", "double", 0, "Specifies the expected noise in odometry's translation estimate from the translational component of the robot's motion.", "", &AMCLConfig::odom_alpha3)));
//#line 58 "../cfg/AMCL.cfg"
      __min__.odom_alpha4 = 0.0;
//#line 58 "../cfg/AMCL.cfg"
      __max__.odom_alpha4 = 10.0;
//#line 58 "../cfg/AMCL.cfg"
      __default__.odom_alpha4 = 0.2;
//#line 58 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("odom_alpha4", "double", 0, "Specifies the expected noise in odometry's translation  estimate from the rotational component of the robot's motion.", "", &AMCLConfig::odom_alpha4)));
//#line 59 "../cfg/AMCL.cfg"
      __min__.odom_alpha5 = 0.0;
//#line 59 "../cfg/AMCL.cfg"
      __max__.odom_alpha5 = 10.0;
//#line 59 "../cfg/AMCL.cfg"
      __default__.odom_alpha5 = 0.2;
//#line 59 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<double>("odom_alpha5", "double", 0, "Translation-related noise parameter (only used if model is omni).", "", &AMCLConfig::odom_alpha5)));
//#line 61 "../cfg/AMCL.cfg"
      __min__.odom_frame_id = "";
//#line 61 "../cfg/AMCL.cfg"
      __max__.odom_frame_id = "";
//#line 61 "../cfg/AMCL.cfg"
      __default__.odom_frame_id = "odom";
//#line 61 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<std::string>("odom_frame_id", "str", 0, "Which frame to use for odometry.", "", &AMCLConfig::odom_frame_id)));
//#line 62 "../cfg/AMCL.cfg"
      __min__.base_frame_id = "";
//#line 62 "../cfg/AMCL.cfg"
      __max__.base_frame_id = "";
//#line 62 "../cfg/AMCL.cfg"
      __default__.base_frame_id = "base_link";
//#line 62 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<std::string>("base_frame_id", "str", 0, "Which frame to use for the robot base.", "", &AMCLConfig::base_frame_id)));
//#line 63 "../cfg/AMCL.cfg"
      __min__.global_frame_id = "";
//#line 63 "../cfg/AMCL.cfg"
      __max__.global_frame_id = "";
//#line 63 "../cfg/AMCL.cfg"
      __default__.global_frame_id = "map";
//#line 63 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<std::string>("global_frame_id", "str", 0, "The name of the coordinate frame published by the localization system.", "", &AMCLConfig::global_frame_id)));
//#line 65 "../cfg/AMCL.cfg"
      __min__.restore_defaults = 0;
//#line 65 "../cfg/AMCL.cfg"
      __max__.restore_defaults = 1;
//#line 65 "../cfg/AMCL.cfg"
      __default__.restore_defaults = 0;
//#line 65 "../cfg/AMCL.cfg"
      __param_descriptions__.push_back(AMCLConfig::AbstractParamDescriptionConstPtr(new AMCLConfig::ParamDescription<bool>("restore_defaults", "bool", 0, "Retsore the default configuration", "", &AMCLConfig::restore_defaults)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<AMCLConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<AMCLConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    AMCLConfig __max__;
    AMCLConfig __min__;
    AMCLConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const AMCLConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static AMCLConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &AMCLConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const AMCLConfig &AMCLConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const AMCLConfig &AMCLConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const AMCLConfig &AMCLConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<AMCLConfig::AbstractParamDescriptionConstPtr> &AMCLConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const AMCLConfigStatics *AMCLConfig::__get_statics__()
  {
    const static AMCLConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = AMCLConfigStatics::get_instance();
    
    return statics;
  }

//#line 48 "../cfg/AMCL.cfg"
      const char * const AMCL_beam_const = "beam";
//#line 48 "../cfg/AMCL.cfg"
      const char * const AMCL_likelihood_field_const = "likelihood_field";
//#line 52 "../cfg/AMCL.cfg"
      const char * const AMCL_diff_const = "diff";
//#line 52 "../cfg/AMCL.cfg"
      const char * const AMCL_omni_const = "omni";
}

#endif // __AMCLRECONFIGURATOR_H__
