//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the costmap_2d package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __costmap_2d__COSTMAP2DCONFIG_H__
#define __costmap_2d__COSTMAP2DCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace costmap_2d
{
  class Costmap2DConfigStatics;
  
  class Costmap2DConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(Costmap2DConfig &config, const Costmap2DConfig &max, const Costmap2DConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const Costmap2DConfig &config1, const Costmap2DConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, Costmap2DConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const Costmap2DConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, Costmap2DConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const Costmap2DConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T Costmap2DConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (Costmap2DConfig::* field);

      virtual void clamp(Costmap2DConfig &config, const Costmap2DConfig &max, const Costmap2DConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const Costmap2DConfig &config1, const Costmap2DConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, Costmap2DConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const Costmap2DConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, Costmap2DConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const Costmap2DConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 15 "../cfg/Costmap2D.cfg"
      double transform_tolerance;
//#line 17 "../cfg/Costmap2D.cfg"
      double update_frequency;
//#line 18 "../cfg/Costmap2D.cfg"
      double publish_frequency;
//#line 20 "../cfg/Costmap2D.cfg"
      double max_obstacle_height;
//#line 21 "../cfg/Costmap2D.cfg"
      double max_obstacle_range;
//#line 22 "../cfg/Costmap2D.cfg"
      double raytrace_range;
//#line 23 "../cfg/Costmap2D.cfg"
      double cost_scaling_factor;
//#line 25 "../cfg/Costmap2D.cfg"
      double inflation_radius;
//#line 26 "../cfg/Costmap2D.cfg"
      std::string footprint;
//#line 27 "../cfg/Costmap2D.cfg"
      double robot_radius;
//#line 29 "../cfg/Costmap2D.cfg"
      bool static_map;
//#line 30 "../cfg/Costmap2D.cfg"
      bool rolling_window;
//#line 31 "../cfg/Costmap2D.cfg"
      int unknown_cost_value;
//#line 34 "../cfg/Costmap2D.cfg"
      int width;
//#line 35 "../cfg/Costmap2D.cfg"
      int height;
//#line 36 "../cfg/Costmap2D.cfg"
      double resolution;
//#line 37 "../cfg/Costmap2D.cfg"
      double origin_x;
//#line 38 "../cfg/Costmap2D.cfg"
      double origin_y;
//#line 40 "../cfg/Costmap2D.cfg"
      bool publish_voxel_map;
//#line 41 "../cfg/Costmap2D.cfg"
      int lethal_cost_threshold;
//#line 42 "../cfg/Costmap2D.cfg"
      std::string map_topic;
//#line 45 "../cfg/Costmap2D.cfg"
      std::string map_type;
//#line 46 "../cfg/Costmap2D.cfg"
      double origin_z;
//#line 47 "../cfg/Costmap2D.cfg"
      double z_resolution;
//#line 48 "../cfg/Costmap2D.cfg"
      int z_voxels;
//#line 49 "../cfg/Costmap2D.cfg"
      int unknown_threshold;
//#line 50 "../cfg/Costmap2D.cfg"
      int mark_threshold;
//#line 51 "../cfg/Costmap2D.cfg"
      bool track_unknown_space;
//#line 53 "../cfg/Costmap2D.cfg"
      bool restore_defaults;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("Costmap2DConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const Costmap2DConfig &__max__ = __getMax__();
      const Costmap2DConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const Costmap2DConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const Costmap2DConfig &__getDefault__();
    static const Costmap2DConfig &__getMax__();
    static const Costmap2DConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const Costmap2DConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void Costmap2DConfig::ParamDescription<std::string>::clamp(Costmap2DConfig &config, const Costmap2DConfig &max, const Costmap2DConfig &min) const
  {
    return;
  }

  class Costmap2DConfigStatics
  {
    friend class Costmap2DConfig;
    
    Costmap2DConfigStatics()
    {
//#line 15 "../cfg/Costmap2D.cfg"
      __min__.transform_tolerance = 0.0;
//#line 15 "../cfg/Costmap2D.cfg"
      __max__.transform_tolerance = 10.0;
//#line 15 "../cfg/Costmap2D.cfg"
      __default__.transform_tolerance = 0.3;
//#line 15 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("transform_tolerance", "double", 0, "Specifies the delay in transform (tf) data that is tolerable in seconds.", "", &Costmap2DConfig::transform_tolerance)));
//#line 17 "../cfg/Costmap2D.cfg"
      __min__.update_frequency = 0.0;
//#line 17 "../cfg/Costmap2D.cfg"
      __max__.update_frequency = 100.0;
//#line 17 "../cfg/Costmap2D.cfg"
      __default__.update_frequency = 5.0;
//#line 17 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("update_frequency", "double", 0, "The frequency in Hz for the map to be updated.", "", &Costmap2DConfig::update_frequency)));
//#line 18 "../cfg/Costmap2D.cfg"
      __min__.publish_frequency = 0.0;
//#line 18 "../cfg/Costmap2D.cfg"
      __max__.publish_frequency = 100.0;
//#line 18 "../cfg/Costmap2D.cfg"
      __default__.publish_frequency = 0.0;
//#line 18 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("publish_frequency", "double", 0, "The frequency in Hz for the map to be publish display information.", "", &Costmap2DConfig::publish_frequency)));
//#line 20 "../cfg/Costmap2D.cfg"
      __min__.max_obstacle_height = 0.0;
//#line 20 "../cfg/Costmap2D.cfg"
      __max__.max_obstacle_height = 50.0;
//#line 20 "../cfg/Costmap2D.cfg"
      __default__.max_obstacle_height = 2.0;
//#line 20 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("max_obstacle_height", "double", 0, "The maximum height of any obstacle to be inserted into the costmap in meters.", "", &Costmap2DConfig::max_obstacle_height)));
//#line 21 "../cfg/Costmap2D.cfg"
      __min__.max_obstacle_range = 0.0;
//#line 21 "../cfg/Costmap2D.cfg"
      __max__.max_obstacle_range = 50.0;
//#line 21 "../cfg/Costmap2D.cfg"
      __default__.max_obstacle_range = 2.5;
//#line 21 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("max_obstacle_range", "double", 0, "The default maximum distance from the robot at which an obstacle will be inserted into the cost map in meters.", "", &Costmap2DConfig::max_obstacle_range)));
//#line 22 "../cfg/Costmap2D.cfg"
      __min__.raytrace_range = 0.0;
//#line 22 "../cfg/Costmap2D.cfg"
      __max__.raytrace_range = 50.0;
//#line 22 "../cfg/Costmap2D.cfg"
      __default__.raytrace_range = 3.0;
//#line 22 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("raytrace_range", "double", 0, "The default range in meters at which to raytrace out obstacles from the map using sensor data.", "", &Costmap2DConfig::raytrace_range)));
//#line 23 "../cfg/Costmap2D.cfg"
      __min__.cost_scaling_factor = 0.0;
//#line 23 "../cfg/Costmap2D.cfg"
      __max__.cost_scaling_factor = 100.0;
//#line 23 "../cfg/Costmap2D.cfg"
      __default__.cost_scaling_factor = 10.0;
//#line 23 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("cost_scaling_factor", "double", 0, "A scaling factor to apply to cost values during inflation.", "", &Costmap2DConfig::cost_scaling_factor)));
//#line 25 "../cfg/Costmap2D.cfg"
      __min__.inflation_radius = 0.0;
//#line 25 "../cfg/Costmap2D.cfg"
      __max__.inflation_radius = 50.0;
//#line 25 "../cfg/Costmap2D.cfg"
      __default__.inflation_radius = 0.55;
//#line 25 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("inflation_radius", "double", 0, "The radius in meters to which the map inflates obstacle cost values.", "", &Costmap2DConfig::inflation_radius)));
//#line 26 "../cfg/Costmap2D.cfg"
      __min__.footprint = "";
//#line 26 "../cfg/Costmap2D.cfg"
      __max__.footprint = "";
//#line 26 "../cfg/Costmap2D.cfg"
      __default__.footprint = "[]";
//#line 26 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<std::string>("footprint", "str", 0, "The footprint of the robot specified in the robot_base_frame coordinate frame as a list in the format: [ [x1, y1], [x2, y2], ...., [xn, yn] ].", "", &Costmap2DConfig::footprint)));
//#line 27 "../cfg/Costmap2D.cfg"
      __min__.robot_radius = 0.0;
//#line 27 "../cfg/Costmap2D.cfg"
      __max__.robot_radius = 10.0;
//#line 27 "../cfg/Costmap2D.cfg"
      __default__.robot_radius = 0.46;
//#line 27 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("robot_radius", "double", 0, "The radius of the robot in meters, this parameter should only be set for circular robots, all others should use the footprint parameter described above.", "", &Costmap2DConfig::robot_radius)));
//#line 29 "../cfg/Costmap2D.cfg"
      __min__.static_map = 0;
//#line 29 "../cfg/Costmap2D.cfg"
      __max__.static_map = 1;
//#line 29 "../cfg/Costmap2D.cfg"
      __default__.static_map = 1;
//#line 29 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<bool>("static_map", "bool", 0, "Whether or not to use the static map to initialize the costmap.", "", &Costmap2DConfig::static_map)));
//#line 30 "../cfg/Costmap2D.cfg"
      __min__.rolling_window = 0;
//#line 30 "../cfg/Costmap2D.cfg"
      __max__.rolling_window = 1;
//#line 30 "../cfg/Costmap2D.cfg"
      __default__.rolling_window = 0;
//#line 30 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<bool>("rolling_window", "bool", 0, "Whether or not to use a rolling window version of the costmap.", "", &Costmap2DConfig::rolling_window)));
//#line 31 "../cfg/Costmap2D.cfg"
      __min__.unknown_cost_value = 0;
//#line 31 "../cfg/Costmap2D.cfg"
      __max__.unknown_cost_value = 255;
//#line 31 "../cfg/Costmap2D.cfg"
      __default__.unknown_cost_value = 0;
//#line 31 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("unknown_cost_value", "int", 0, "The value for which a cost should be considered unknown when reading in a map from the map server.", "", &Costmap2DConfig::unknown_cost_value)));
//#line 34 "../cfg/Costmap2D.cfg"
      __min__.width = 0;
//#line 34 "../cfg/Costmap2D.cfg"
      __max__.width = 20;
//#line 34 "../cfg/Costmap2D.cfg"
      __default__.width = 0;
//#line 34 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("width", "int", 0, "The width of the map in meters.", "", &Costmap2DConfig::width)));
//#line 35 "../cfg/Costmap2D.cfg"
      __min__.height = 0;
//#line 35 "../cfg/Costmap2D.cfg"
      __max__.height = 20;
//#line 35 "../cfg/Costmap2D.cfg"
      __default__.height = 10;
//#line 35 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("height", "int", 0, "The height of the map in meters.", "", &Costmap2DConfig::height)));
//#line 36 "../cfg/Costmap2D.cfg"
      __min__.resolution = 0.0;
//#line 36 "../cfg/Costmap2D.cfg"
      __max__.resolution = 50.0;
//#line 36 "../cfg/Costmap2D.cfg"
      __default__.resolution = 0.05;
//#line 36 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("resolution", "double", 0, "The resolution of the map in meters/cell.", "", &Costmap2DConfig::resolution)));
//#line 37 "../cfg/Costmap2D.cfg"
      __min__.origin_x = 0.0;
//#line 37 "../cfg/Costmap2D.cfg"
      __max__.origin_x = std::numeric_limits<double>::infinity();
//#line 37 "../cfg/Costmap2D.cfg"
      __default__.origin_x = 0.0;
//#line 37 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("origin_x", "double", 0, "The x origin of the map in the global frame in meters.", "", &Costmap2DConfig::origin_x)));
//#line 38 "../cfg/Costmap2D.cfg"
      __min__.origin_y = 0.0;
//#line 38 "../cfg/Costmap2D.cfg"
      __max__.origin_y = std::numeric_limits<double>::infinity();
//#line 38 "../cfg/Costmap2D.cfg"
      __default__.origin_y = 0.0;
//#line 38 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("origin_y", "double", 0, "The y origin of the map in the global frame in meters.", "", &Costmap2DConfig::origin_y)));
//#line 40 "../cfg/Costmap2D.cfg"
      __min__.publish_voxel_map = 0;
//#line 40 "../cfg/Costmap2D.cfg"
      __max__.publish_voxel_map = 1;
//#line 40 "../cfg/Costmap2D.cfg"
      __default__.publish_voxel_map = 0;
//#line 40 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<bool>("publish_voxel_map", "bool", 0, "Whether or not to publish the underlying voxel grid for visualization purposes.", "", &Costmap2DConfig::publish_voxel_map)));
//#line 41 "../cfg/Costmap2D.cfg"
      __min__.lethal_cost_threshold = 0;
//#line 41 "../cfg/Costmap2D.cfg"
      __max__.lethal_cost_threshold = 255;
//#line 41 "../cfg/Costmap2D.cfg"
      __default__.lethal_cost_threshold = 100;
//#line 41 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("lethal_cost_threshold", "int", 0, "The threshold value at which to consider a cost lethal when reading in a map from the map server.", "", &Costmap2DConfig::lethal_cost_threshold)));
//#line 42 "../cfg/Costmap2D.cfg"
      __min__.map_topic = "";
//#line 42 "../cfg/Costmap2D.cfg"
      __max__.map_topic = "";
//#line 42 "../cfg/Costmap2D.cfg"
      __default__.map_topic = "map";
//#line 42 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<std::string>("map_topic", "str", 0, "The topic that the costmap subscribes to for the static map.", "", &Costmap2DConfig::map_topic)));
//#line 45 "../cfg/Costmap2D.cfg"
      __min__.map_type = "";
//#line 45 "../cfg/Costmap2D.cfg"
      __max__.map_type = "";
//#line 45 "../cfg/Costmap2D.cfg"
      __default__.map_type = "costmap";
//#line 45 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<std::string>("map_type", "str", 0, "What map type to use. voxel or costmap are the supported types", "{'enum_description': 'An enum to set the map type', 'enum': [{'srcline': 13, 'description': 'Use VoxelCostmap2D', 'srcfile': '../cfg/Costmap2D.cfg', 'cconsttype': 'const char * const', 'value': 'voxel', 'ctype': 'std::string', 'type': 'str', 'name': 'voxel_const'}, {'srcline': 13, 'description': 'Use Costmap2D', 'srcfile': '../cfg/Costmap2D.cfg', 'cconsttype': 'const char * const', 'value': 'costmap', 'ctype': 'std::string', 'type': 'str', 'name': 'costmap_const'}]}", &Costmap2DConfig::map_type)));
//#line 46 "../cfg/Costmap2D.cfg"
      __min__.origin_z = 0.0;
//#line 46 "../cfg/Costmap2D.cfg"
      __max__.origin_z = std::numeric_limits<double>::infinity();
//#line 46 "../cfg/Costmap2D.cfg"
      __default__.origin_z = 0.0;
//#line 46 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("origin_z", "double", 0, "The z origin of the map in meters.", "", &Costmap2DConfig::origin_z)));
//#line 47 "../cfg/Costmap2D.cfg"
      __min__.z_resolution = 0.0;
//#line 47 "../cfg/Costmap2D.cfg"
      __max__.z_resolution = 50.0;
//#line 47 "../cfg/Costmap2D.cfg"
      __default__.z_resolution = 0.2;
//#line 47 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<double>("z_resolution", "double", 0, "The z resolution of the map in meters/cell.", "", &Costmap2DConfig::z_resolution)));
//#line 48 "../cfg/Costmap2D.cfg"
      __min__.z_voxels = 0;
//#line 48 "../cfg/Costmap2D.cfg"
      __max__.z_voxels = 16;
//#line 48 "../cfg/Costmap2D.cfg"
      __default__.z_voxels = 10;
//#line 48 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("z_voxels", "int", 0, "The number of voxels to in each vertical column.", "", &Costmap2DConfig::z_voxels)));
//#line 49 "../cfg/Costmap2D.cfg"
      __min__.unknown_threshold = 0;
//#line 49 "../cfg/Costmap2D.cfg"
      __max__.unknown_threshold = 16;
//#line 49 "../cfg/Costmap2D.cfg"
      __default__.unknown_threshold = 15;
//#line 49 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("unknown_threshold", "int", 0, "The number of unknown cells allowed in a column considered to be known", "", &Costmap2DConfig::unknown_threshold)));
//#line 50 "../cfg/Costmap2D.cfg"
      __min__.mark_threshold = 0;
//#line 50 "../cfg/Costmap2D.cfg"
      __max__.mark_threshold = 16;
//#line 50 "../cfg/Costmap2D.cfg"
      __default__.mark_threshold = 0;
//#line 50 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<int>("mark_threshold", "int", 0, "The maximum number of marked cells allowed in a column considered to be free", "", &Costmap2DConfig::mark_threshold)));
//#line 51 "../cfg/Costmap2D.cfg"
      __min__.track_unknown_space = 0;
//#line 51 "../cfg/Costmap2D.cfg"
      __max__.track_unknown_space = 1;
//#line 51 "../cfg/Costmap2D.cfg"
      __default__.track_unknown_space = 0;
//#line 51 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<bool>("track_unknown_space", "bool", 0, "Specifies whether or not to track what space in the costmap is unknown", "", &Costmap2DConfig::track_unknown_space)));
//#line 53 "../cfg/Costmap2D.cfg"
      __min__.restore_defaults = 0;
//#line 53 "../cfg/Costmap2D.cfg"
      __max__.restore_defaults = 1;
//#line 53 "../cfg/Costmap2D.cfg"
      __default__.restore_defaults = 0;
//#line 53 "../cfg/Costmap2D.cfg"
      __param_descriptions__.push_back(Costmap2DConfig::AbstractParamDescriptionConstPtr(new Costmap2DConfig::ParamDescription<bool>("restore_defaults", "bool", 0, "Restore to the original configuration", "", &Costmap2DConfig::restore_defaults)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<Costmap2DConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<Costmap2DConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    Costmap2DConfig __max__;
    Costmap2DConfig __min__;
    Costmap2DConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const Costmap2DConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static Costmap2DConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &Costmap2DConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const Costmap2DConfig &Costmap2DConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const Costmap2DConfig &Costmap2DConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const Costmap2DConfig &Costmap2DConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<Costmap2DConfig::AbstractParamDescriptionConstPtr> &Costmap2DConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const Costmap2DConfigStatics *Costmap2DConfig::__get_statics__()
  {
    const static Costmap2DConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = Costmap2DConfigStatics::get_instance();
    
    return statics;
  }

//#line 13 "../cfg/Costmap2D.cfg"
      const char * const Costmap2D_voxel_const = "voxel";
//#line 13 "../cfg/Costmap2D.cfg"
      const char * const Costmap2D_costmap_const = "costmap";
}

#endif // __COSTMAP2DRECONFIGURATOR_H__
