//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the move_base package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __move_base__MOVEBASECONFIG_H__
#define __move_base__MOVEBASECONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace move_base
{
  class MoveBaseConfigStatics;
  
  class MoveBaseConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(MoveBaseConfig &config, const MoveBaseConfig &max, const MoveBaseConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const MoveBaseConfig &config1, const MoveBaseConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, MoveBaseConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const MoveBaseConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, MoveBaseConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const MoveBaseConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T MoveBaseConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (MoveBaseConfig::* field);

      virtual void clamp(MoveBaseConfig &config, const MoveBaseConfig &max, const MoveBaseConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const MoveBaseConfig &config1, const MoveBaseConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, MoveBaseConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const MoveBaseConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, MoveBaseConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const MoveBaseConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 10 "../cfg/MoveBase.cfg"
      std::string base_global_planner;
//#line 11 "../cfg/MoveBase.cfg"
      std::string base_local_planner;
//#line 15 "../cfg/MoveBase.cfg"
      double planner_frequency;
//#line 16 "../cfg/MoveBase.cfg"
      double controller_frequency;
//#line 17 "../cfg/MoveBase.cfg"
      double planner_patience;
//#line 18 "../cfg/MoveBase.cfg"
      double controller_patience;
//#line 19 "../cfg/MoveBase.cfg"
      double conservative_reset_dist;
//#line 21 "../cfg/MoveBase.cfg"
      bool recovery_behavior_enabled;
//#line 23 "../cfg/MoveBase.cfg"
      bool clearing_rotation_allowed;
//#line 24 "../cfg/MoveBase.cfg"
      bool shutdown_costmaps;
//#line 26 "../cfg/MoveBase.cfg"
      double oscillation_timeout;
//#line 27 "../cfg/MoveBase.cfg"
      double oscillation_distance;
//#line 29 "../cfg/MoveBase.cfg"
      bool restore_defaults;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("MoveBaseConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const MoveBaseConfig &__max__ = __getMax__();
      const MoveBaseConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const MoveBaseConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const MoveBaseConfig &__getDefault__();
    static const MoveBaseConfig &__getMax__();
    static const MoveBaseConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const MoveBaseConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void MoveBaseConfig::ParamDescription<std::string>::clamp(MoveBaseConfig &config, const MoveBaseConfig &max, const MoveBaseConfig &min) const
  {
    return;
  }

  class MoveBaseConfigStatics
  {
    friend class MoveBaseConfig;
    
    MoveBaseConfigStatics()
    {
//#line 10 "../cfg/MoveBase.cfg"
      __min__.base_global_planner = "";
//#line 10 "../cfg/MoveBase.cfg"
      __max__.base_global_planner = "";
//#line 10 "../cfg/MoveBase.cfg"
      __default__.base_global_planner = "navfn/NavfnROS";
//#line 10 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<std::string>("base_global_planner", "str", 0, "The name of the plugin for the global planner to use with move_base.", "", &MoveBaseConfig::base_global_planner)));
//#line 11 "../cfg/MoveBase.cfg"
      __min__.base_local_planner = "";
//#line 11 "../cfg/MoveBase.cfg"
      __max__.base_local_planner = "";
//#line 11 "../cfg/MoveBase.cfg"
      __default__.base_local_planner = "base_local_planner/TrajectoryPlannerROS";
//#line 11 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<std::string>("base_local_planner", "str", 0, "The name of the plugin for the local planner to use with move_base.", "", &MoveBaseConfig::base_local_planner)));
//#line 15 "../cfg/MoveBase.cfg"
      __min__.planner_frequency = 0.0;
//#line 15 "../cfg/MoveBase.cfg"
      __max__.planner_frequency = 100.0;
//#line 15 "../cfg/MoveBase.cfg"
      __default__.planner_frequency = 0.0;
//#line 15 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("planner_frequency", "double", 0, "The rate in Hz at which to run the planning loop.", "", &MoveBaseConfig::planner_frequency)));
//#line 16 "../cfg/MoveBase.cfg"
      __min__.controller_frequency = 0.0;
//#line 16 "../cfg/MoveBase.cfg"
      __max__.controller_frequency = 100.0;
//#line 16 "../cfg/MoveBase.cfg"
      __default__.controller_frequency = 20.0;
//#line 16 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("controller_frequency", "double", 0, "The rate in Hz at which to run the control loop and send velocity commands to the base.", "", &MoveBaseConfig::controller_frequency)));
//#line 17 "../cfg/MoveBase.cfg"
      __min__.planner_patience = 0.0;
//#line 17 "../cfg/MoveBase.cfg"
      __max__.planner_patience = 100.0;
//#line 17 "../cfg/MoveBase.cfg"
      __default__.planner_patience = 5.0;
//#line 17 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("planner_patience", "double", 0, "How long the planner will wait in seconds in an attempt to find a valid plan before space-clearing operations are performed.", "", &MoveBaseConfig::planner_patience)));
//#line 18 "../cfg/MoveBase.cfg"
      __min__.controller_patience = 0.0;
//#line 18 "../cfg/MoveBase.cfg"
      __max__.controller_patience = 100.0;
//#line 18 "../cfg/MoveBase.cfg"
      __default__.controller_patience = 5.0;
//#line 18 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("controller_patience", "double", 0, "How long the controller will wait in seconds without receiving a valid control before space-clearing operations are performed.", "", &MoveBaseConfig::controller_patience)));
//#line 19 "../cfg/MoveBase.cfg"
      __min__.conservative_reset_dist = 0.0;
//#line 19 "../cfg/MoveBase.cfg"
      __max__.conservative_reset_dist = 50.0;
//#line 19 "../cfg/MoveBase.cfg"
      __default__.conservative_reset_dist = 3.0;
//#line 19 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("conservative_reset_dist", "double", 0, "The distance away from the robot in meters at which obstacles will be cleared from the costmap when attempting to clear space in the map.", "", &MoveBaseConfig::conservative_reset_dist)));
//#line 21 "../cfg/MoveBase.cfg"
      __min__.recovery_behavior_enabled = 0;
//#line 21 "../cfg/MoveBase.cfg"
      __max__.recovery_behavior_enabled = 1;
//#line 21 "../cfg/MoveBase.cfg"
      __default__.recovery_behavior_enabled = 1;
//#line 21 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<bool>("recovery_behavior_enabled", "bool", 0, "Whether or not to enable the move_base recovery behaviors to attempt to clear out space.", "", &MoveBaseConfig::recovery_behavior_enabled)));
//#line 23 "../cfg/MoveBase.cfg"
      __min__.clearing_rotation_allowed = 0;
//#line 23 "../cfg/MoveBase.cfg"
      __max__.clearing_rotation_allowed = 1;
//#line 23 "../cfg/MoveBase.cfg"
      __default__.clearing_rotation_allowed = 1;
//#line 23 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<bool>("clearing_rotation_allowed", "bool", 0, "Determines whether or not the robot will attempt an in-place rotation when attempting to clear out space.", "", &MoveBaseConfig::clearing_rotation_allowed)));
//#line 24 "../cfg/MoveBase.cfg"
      __min__.shutdown_costmaps = 0;
//#line 24 "../cfg/MoveBase.cfg"
      __max__.shutdown_costmaps = 1;
//#line 24 "../cfg/MoveBase.cfg"
      __default__.shutdown_costmaps = 0;
//#line 24 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<bool>("shutdown_costmaps", "bool", 0, "Determines whether or not to shutdown the costmaps of the node when move_base is in an inactive state", "", &MoveBaseConfig::shutdown_costmaps)));
//#line 26 "../cfg/MoveBase.cfg"
      __min__.oscillation_timeout = 0.0;
//#line 26 "../cfg/MoveBase.cfg"
      __max__.oscillation_timeout = 60.0;
//#line 26 "../cfg/MoveBase.cfg"
      __default__.oscillation_timeout = 0.0;
//#line 26 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("oscillation_timeout", "double", 0, "How long in seconds to allow for oscillation before executing recovery behaviors.", "", &MoveBaseConfig::oscillation_timeout)));
//#line 27 "../cfg/MoveBase.cfg"
      __min__.oscillation_distance = 0.0;
//#line 27 "../cfg/MoveBase.cfg"
      __max__.oscillation_distance = 10.0;
//#line 27 "../cfg/MoveBase.cfg"
      __default__.oscillation_distance = 0.5;
//#line 27 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<double>("oscillation_distance", "double", 0, "How far in meters the robot must move to be considered not to be oscillating.", "", &MoveBaseConfig::oscillation_distance)));
//#line 29 "../cfg/MoveBase.cfg"
      __min__.restore_defaults = 0;
//#line 29 "../cfg/MoveBase.cfg"
      __max__.restore_defaults = 1;
//#line 29 "../cfg/MoveBase.cfg"
      __default__.restore_defaults = 0;
//#line 29 "../cfg/MoveBase.cfg"
      __param_descriptions__.push_back(MoveBaseConfig::AbstractParamDescriptionConstPtr(new MoveBaseConfig::ParamDescription<bool>("restore_defaults", "bool", 0, "Restore to the original configuration", "", &MoveBaseConfig::restore_defaults)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<MoveBaseConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<MoveBaseConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    MoveBaseConfig __max__;
    MoveBaseConfig __min__;
    MoveBaseConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const MoveBaseConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static MoveBaseConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &MoveBaseConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const MoveBaseConfig &MoveBaseConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const MoveBaseConfig &MoveBaseConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const MoveBaseConfig &MoveBaseConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<MoveBaseConfig::AbstractParamDescriptionConstPtr> &MoveBaseConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const MoveBaseConfigStatics *MoveBaseConfig::__get_statics__()
  {
    const static MoveBaseConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = MoveBaseConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __MOVEBASERECONFIGURATOR_H__
