## *********************************************************
## 
## File autogenerated for the move_base package 
## by the dynamic_reconfigure package.
## Please do not edit.
## 
## ********************************************************/

##**********************************************************
## Software License Agreement (BSD License)
##
##  Copyright (c) 2008, Willow Garage, Inc.
##  All rights reserved.
##
##  Redistribution and use in source and binary forms, with or without
##  modification, are permitted provided that the following conditions
##  are met:
##
##   * Redistributions of source code must retain the above copyright
##     notice, this list of conditions and the following disclaimer.
##   * Redistributions in binary form must reproduce the above
##     copyright notice, this list of conditions and the following
##     disclaimer in the documentation and/or other materials provided
##     with the distribution.
##   * Neither the name of the Willow Garage nor the names of its
##     contributors may be used to endorse or promote products derived
##     from this software without specific prior written permission.
##
##  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
##  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
##  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
##  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
##  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
##  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
##  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
##  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
##  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
##  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
##  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
##  POSSIBILITY OF SUCH DAMAGE.
##**********************************************************/

config_description = [{'srcline': 10, 'description': 'The name of the plugin for the global planner to use with move_base.', 'max': '', 'cconsttype': 'const char * const', 'ctype': 'std::string', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'base_global_planner', 'edit_method': '', 'default': 'navfn/NavfnROS', 'level': 0, 'min': '', 'type': 'str'}, {'srcline': 11, 'description': 'The name of the plugin for the local planner to use with move_base.', 'max': '', 'cconsttype': 'const char * const', 'ctype': 'std::string', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'base_local_planner', 'edit_method': '', 'default': 'base_local_planner/TrajectoryPlannerROS', 'level': 0, 'min': '', 'type': 'str'}, {'srcline': 15, 'description': 'The rate in Hz at which to run the planning loop.', 'max': 100.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'planner_frequency', 'edit_method': '', 'default': 0.0, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 16, 'description': 'The rate in Hz at which to run the control loop and send velocity commands to the base.', 'max': 100.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'controller_frequency', 'edit_method': '', 'default': 20.0, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 17, 'description': 'How long the planner will wait in seconds in an attempt to find a valid plan before space-clearing operations are performed.', 'max': 100.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'planner_patience', 'edit_method': '', 'default': 5.0, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 18, 'description': 'How long the controller will wait in seconds without receiving a valid control before space-clearing operations are performed.', 'max': 100.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'controller_patience', 'edit_method': '', 'default': 5.0, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 19, 'description': 'The distance away from the robot in meters at which obstacles will be cleared from the costmap when attempting to clear space in the map.', 'max': 50.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'conservative_reset_dist', 'edit_method': '', 'default': 3.0, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 21, 'description': 'Whether or not to enable the move_base recovery behaviors to attempt to clear out space.', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'recovery_behavior_enabled', 'edit_method': '', 'default': True, 'level': 0, 'min': False, 'type': 'bool'}, {'srcline': 23, 'description': 'Determines whether or not the robot will attempt an in-place rotation when attempting to clear out space.', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'clearing_rotation_allowed', 'edit_method': '', 'default': True, 'level': 0, 'min': False, 'type': 'bool'}, {'srcline': 24, 'description': 'Determines whether or not to shutdown the costmaps of the node when move_base is in an inactive state', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'shutdown_costmaps', 'edit_method': '', 'default': False, 'level': 0, 'min': False, 'type': 'bool'}, {'srcline': 26, 'description': 'How long in seconds to allow for oscillation before executing recovery behaviors.', 'max': 60.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'oscillation_timeout', 'edit_method': '', 'default': 0.0, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 27, 'description': 'How far in meters the robot must move to be considered not to be oscillating.', 'max': 10.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'oscillation_distance', 'edit_method': '', 'default': 0.5, 'level': 0, 'min': 0.0, 'type': 'double'}, {'srcline': 29, 'description': 'Restore to the original configuration', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/MoveBase.cfg', 'name': 'restore_defaults', 'edit_method': '', 'default': False, 'level': 0, 'min': False, 'type': 'bool'}]

min = {}
max = {}
defaults = {}
level = {}
type = {}
all_level = 0

for param in config_description:
    min[param['name']] = param['min']
    max[param['name']] = param['max']
    defaults[param['name']] = param['default']
    level[param['name']] = param['level']
    type[param['name']] = param['type']
    all_level = all_level | param['level']

